//This class is a dynamic byte box.  You can put things in & get them out,
//but you must do it in the same order, as it doen't store types, just bytes.
//It uses no padding, and expects C char* to be null terminated strings.
//You can use it several times by emptying it.
//It can 'take over' a chunk of memory, and volenteer itself as memory, by 
//using take_over and pointer.
//It will ALWAYS try to deallocate the memory it uses with free, when its
//destructor is called, so it should only take over memory that it can free,
//and anthing that uses it's memory should not free it (or mess with it in
//any way except looking).
//Define your own version by public inheritance of this class, add functions
//to store and get aplication specific objects.  Note that you can't overload
//functions in this class with your own versions of get & store, as the versions
//in the derived class will hide the ones here, but thats OK, just write fns 
//that call these fns like this ByteStore::store( <stuff> ).

//define _ByteStore_platform_dependant when writting code to work
//with data saved using old versions of Bytestore that work with platform
//dependant code

#ifndef _ByteStore_h
#define _ByteStore_h 1



#include <stdlib.h>
#include <String.h>

class ByteStore
   {
   public:
	ByteStore()
		{start=NULL; expand_by=0; size=0;
		 next_get_index=0; next_free_index=0;};
	ByteStore(int start_size) 
		{start=(char*)malloc(start_size); expand_by=0; size=start_size;
		 next_get_index=0; next_free_index=0;};
	ByteStore(int start_size, int expand_by_) 
		{start=(char*)malloc(start_size); expand_by=expand_by_; 
		 size=start_size;
		 next_get_index=0; next_free_index=0;};
	~ByteStore();

	//returns address for OK, or neg for error
	int store(const char ch);
	int store(const char* ch_p);
	// this stores 32 leaste significant bits of an int, reguardless of 
	// sizeof(int), unless _ByteStore_platform_dependant is defined
	int store(const int int_n);
	int store(const String& string);	

	void replace(const int int_n, const int address);

	int resize(int required_bytes); 
	void next_get_is_first() {next_get_index=0;};	

	void get(char& ch);
	void get(char* ch_p);
	void get(int& int_n);
	void get(String& string);

	char get_char();
	int get_int();
	char* get_char_ptr();

	int allocated_size() {return size;};
	int used_size() {return next_free_index;};
	void take_over (char* ch_p, int the_size)
		{if (start!=NULL) free(start); start=ch_p; size=the_size;
		 next_free_index=the_size; next_get_index=0;};
	char* pointer() {return start;};
	void empty() {next_free_index=0;};
	void get_from_begining() {next_get_index=0;};	
	int next_get_address() {return next_get_index;};

   protected:
	int size;
	char* start;
	int expand_by;
	int next_free_index;
	int next_get_index;
	int err;
   };



#endif
