%{
#include "ssci-lang.h"
#include "functions.h"
#include <stdlib.h>


extern char* flex_input_ptr;

int new_yyinput (char* buf, int max_size); // NB assumes input ends with null as
						// first char
int new_yyinput (char* buf, int max_size) // NB assumes input ends with null as
						// first char
   {
   int n=0;
   while ( ((*flex_input_ptr)!='\0') && (n<=max_size) )
	{*(buf+(n++))=*(flex_input_ptr++);};
   return n;
   };

int yywrap()
        {
        return 1;
        }

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) (result=new_yyinput(buf, max_size))

extern String string_token;  
	// used to pass the value of strings back from the lexer

%}

%%

\"[^\"\n]*[\"] {string_token=yytext; unquote(string_token); return STRING;}

\n						{return EOL;}

"get"[ \t]*"resource"|"gr"			{return GET_RESOURCE;}
"new"[ \t]*"resource"|"nr" 			{return NEW_RESOURCE;}
"delete"[ \t]*"resource"|"dr"			{return DELETE_RESOURCE;}
"update"[ \t]*"resource"|"ur" 			{return UPDATE_RESOURCE;}
"add"[ \t]*"resource"|"ar" 			{return ADD_RESOURCE;}
"remove"[ \t]*"resource"|"rr" 			{return REMOVE_RESOURCE;}
"resources"[ \t]*"in""intersection"|"ri"     {return RESOURCES_IN_INTERSECTION;}
"urls"[ \t]*"in""intersection"|"ui"     	{return URLS_IN_INTERSECTION;}
"subjects"[ \t]*"of"[ \t]*"resource"|"sr"	{return SUBJECTS_OF_RESOURCE;}
"set"[ \t]*"subjects"[ \t]*"of"[ \t]*"resource"|"ss"	{
					return SET_SUBJECTS_OF_RESOURCE;}
"new"[ \t]*"subject"|"ns" 			{return NEW_SUBJECT;}
"delete"[ \t]*"subject"|"ds" 			{return DELETE_SUBJECT;}
"add"[ \t]*"subject"|"as" 			{return ADD_SUBJECT;}
"remove"[ \t]*"subject"|"rs" 			{return REMOVE_SUBJECT;}
"parents"[ \t]*"of"[ \t]*"subject"|"ps" 	{return PARENTS_OF_SUBJECT;}
"children"[ \t]*"of"[ \t]*"subject"|"cs" 	{return CHILDREN_OF_SUBJECT;}
"intersectors"[ \t]*"of"[ \t]*"subject"|"is"  {return INTERSECTORS_OF_SUBJECT;}
"subjects"[ \t]*"list"|"sl"			{return SUBJECTS_LIST;}
"urls"[ \t]*"list"|"ul"				{return URLS_LIST;}
"reorganise"|"ro"				{return REORGANISE;}
"text"[ \t]*"dump"|"td"				{return TEXT_DUMP;}

"neighbor"[ \t]*"nodes"|"nn"			{return NEIGHBOR_NODES;}
"resources"[ \t]*"in"[ \t]*"node"|"rn"		{return RESOURCES_IN_NODE;}

[ \t] ;  /* ignore whitespace */

. return ERROR;
%%
