
#include <iostream.h>
#include <String.h>
#include "ssdbm.h"

const String CS = " "; // column separator
const String RS = "\n"; // row separator

void output_SS_interconection_table (SSDBM& ssdbm);


int main(int argc, char* argv[])
   {
   if (argc!=2) cout <<"arg 1 = database name \n";
   else 
     {
     SS_Error error;
     SSDBM ssdbm(error, argv[1], GDBM_WRCREAT);
     if (error==OK)
       {
	output_SS_interconection_table (ssdbm);
       }
      else
	{cerr<<argv[0]<< " error opening subject space - can only open subject space by one program at a time\n";};
    };
   };


void output_SS_interconection_table (SSDBM& ssdbm)
  {
  Set_String_ col_subjects;
  ssdbm.subjects_list(col_subjects);

/*
  //column lables
  cout << "|intersect|" << CS;
  col_subjects.next_member_returns_first();
  while (col_subjects.can_use_get_next_member())
	{
	cout << col_subjects.get_next_member()<<CS;
	};
  cout << RS;
*/

  Set_String_ row_subjects = col_subjects;

  //row loop
  row_subjects.next_member_returns_first();
  while (row_subjects.can_use_get_next_member())
    {
    String row=row_subjects.get_next_member();
    //row label
//    cout << row << CS;

    //column loop
    col_subjects.next_member_returns_first();
    while (col_subjects.can_use_get_next_member())
	{
	String col = col_subjects.get_next_member();
	Set_String_ intersection;
	intersection.add_member(row);
	intersection.add_member(col);
	Set_String_ urls;
	ssdbm.urls_in_intersection(intersection, urls);
	if (urls.no_of_members()!=0) 
		cout << urls.no_of_members() << CS << row<<CS<<col<<RS;
	};

    cout << RS;
    };
  
  }; 
